/* IMPORT */
import { exit } from 'specialist';
import { inspect } from './utils.js';
import { getReportSimple, getReportAdvanced, getReportESM, getReportLicense, getReportGitHub, getReportOwner, getReportDuplicates } from './utils.js';
import { printReportSimple, printReportAdvanced, printReportESM, printReportLicense, printReportGitHub, printReportOwner, printReportDuplicates } from './utils.js';
/* MAIN */
const Depsman = new class {
    async get(type) {
        if (type === 'simple') {
            return getReportSimple();
        }
        else if (type === 'advanced') {
            return getReportAdvanced();
        }
        else if (type === 'esm') {
            return getReportESM();
        }
        else if (type === 'license') {
            return getReportLicense();
        }
        else if (type === 'github') {
            return getReportGitHub();
        }
        else if (type === 'owner') {
            return getReportOwner();
        }
        else if (type === 'duplicates') {
            return getReportDuplicates();
        }
        else {
            exit(`Unsupported report: "${type}"`);
        }
    }
    async printJSON(type) {
        if (type === 'simple') {
            inspect(await getReportSimple());
        }
        else if (type === 'advanced') {
            inspect(await getReportAdvanced());
        }
        else if (type === 'esm') {
            inspect(await getReportESM());
        }
        else if (type === 'license') {
            inspect(await getReportLicense());
        }
        else if (type === 'github') {
            inspect(await getReportGitHub());
        }
        else if (type === 'owner') {
            inspect(await getReportOwner());
        }
        else if (type === 'duplicates') {
            inspect(await getReportDuplicates());
        }
        else {
            exit(`Unsupported report: "${type}"`);
        }
    }
    async printHuman(type) {
        if (type === 'simple') {
            printReportSimple(await getReportSimple());
        }
        else if (type === 'advanced') {
            printReportAdvanced(await getReportAdvanced());
        }
        else if (type === 'esm') {
            printReportESM(await getReportESM());
        }
        else if (type === 'license') {
            printReportLicense(await getReportLicense());
        }
        else if (type === 'github') {
            printReportGitHub(await getReportGitHub());
        }
        else if (type === 'owner') {
            printReportOwner(await getReportOwner());
        }
        else if (type === 'duplicates') {
            printReportDuplicates(await getReportDuplicates());
        }
        else {
            exit(`Unsupported report: "${type}"`);
        }
    }
};
/* EXPORT */
export default Depsman;
