import type { DependencyRoot, DependencyNode, DependencySimple, DependencyAdvanced } from './types';
import type { Package, Repository } from './types';
import type { ReportSimple, ReportAdvanced, ReportESM, ReportLicense, ReportGitHub, ReportOwner, ReportDuplicates } from './types';
declare const inspect: (value: object) => void;
declare const partition: <T>(arr: ArrayLike<T>, filterer: (value: T, index: number, arr: ArrayLike<T>) => boolean) => [T[], T[]];
declare const getCachedJSON: <T>(id: string, fn: () => T) => Promise<T>;
declare const getFileJSON: (filePath: string) => unknown | undefined;
declare const isPackage: (value: unknown) => value is any;
declare const getDependencyId: (name: string, version: string) => string;
declare const getDependencyName: (name: string, node: DependencyNode) => string;
declare const getDependencyPackage: (name: string, version: string) => Package;
declare const getDependencyAdvanced: (simple: DependencySimple, packages: Package[], packagesMap: Record<string, Package>) => Promise<DependencyAdvanced>;
declare const getRepository: (registry: string | undefined, pkg: Package) => string | undefined;
declare const getRepositoryFromPackage: (pkg: Package) => string;
declare const getRepositoryContent: (repository: string) => string;
declare const getRepositoryOwnerAndRepo: (repository: string) => [string, string] | undefined;
declare const getRepositoryMetadata: (repository: string) => Promise<Repository | undefined>;
declare const getRepositoryReadme: (repository: string) => Promise<[string, string] | undefined>;
declare const getRepositoryLicense: (repository: string) => Promise<[string, string] | undefined>;
declare const getDependenciesPackages: () => Promise<Package[]>;
declare const getDependenciesSimple: (tree: DependencyRoot) => DependencySimple[];
declare const getDependenciesAdvanced: (simples: DependencySimple[], packages: Package[]) => Promise<DependencyAdvanced[]>;
declare const getDependenciesTree: () => DependencyRoot;
declare const getReportSimple: () => Promise<ReportSimple>;
declare const getReportAdvanced: () => Promise<ReportAdvanced>;
declare const getReportESM: () => Promise<ReportESM>;
declare const getReportLicense: () => Promise<ReportLicense>;
declare const getReportGitHub: () => Promise<ReportGitHub>;
declare const getReportOwner: () => Promise<ReportOwner>;
declare const getReportDuplicates: () => Promise<ReportDuplicates>;
declare const printReportSimple: (report: ReportSimple) => Promise<void>;
declare const printReportAdvanced: (report: ReportAdvanced) => Promise<void>;
declare const printReportESM: (report: ReportESM) => Promise<void>;
declare const printReportLicense: (report: ReportLicense) => Promise<void>;
declare const printReportGitHub: (report: ReportGitHub) => Promise<void>;
declare const printReportOwner: (report: ReportOwner) => Promise<void>;
declare const printReportDuplicates: (report: ReportDuplicates) => Promise<void>;
export { inspect, partition };
export { getCachedJSON, getFileJSON, isPackage };
export { getDependencyId, getDependencyName, getDependencyPackage, getDependencyAdvanced };
export { getRepository, getRepositoryFromPackage, getRepositoryContent, getRepositoryOwnerAndRepo, getRepositoryMetadata, getRepositoryReadme, getRepositoryLicense };
export { getDependenciesPackages, getDependenciesSimple, getDependenciesAdvanced, getDependenciesTree };
export { getReportSimple, getReportAdvanced, getReportESM, getReportLicense, getReportGitHub, getReportOwner, getReportDuplicates };
export { printReportSimple, printReportAdvanced, printReportESM, printReportLicense, printReportGitHub, printReportOwner, printReportDuplicates };
